﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using System.Diagnostics;
using Infragistics.Windows;
using Microsoft.Windows.Themes;

namespace CVPcombo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void XamDataGrid_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            if (e.OriginalSource is ButtonChrome)
            {                
                var aShowProblem = true;
                var aGrid = (XamDataGrid)sender;
                var aHitTest = System.Windows.Media.VisualTreeHelper.HitTest(aGrid, e.GetPosition(aGrid));
                if (aHitTest != null && aHitTest.VisualHit != null)
                {
                    var aVisualHit = aHitTest.VisualHit;
                    var aCellValuePresenter = aVisualHit.FindVisualParentNullable<CellValuePresenter>();
                    if (aCellValuePresenter != null)
                    {
                        var aRecordPresenter = aCellValuePresenter.FindVisualParent<RecordPresenter>();
                        var aRecord = aRecordPresenter.Record;
                        if (aShowProblem)
                        {
                            if (!Keyboard.IsKeyDown(Key.LeftCtrl))
                            {
                                aGrid.SelectedItems.Records.Clear();
                            }                            
                            aGrid.SelectedItems.Records.Add(aRecord);
                        }
                    }
                }
            }            
        }
    }
}

public static class CVisualTreeUtils
{

    public static T FindVisualParent<T>(this DependencyObject aDo) where T : class
    {
        var aVisualParent = FindVisualParentNullable<T>(aDo);
        if (aVisualParent == null)
        {
            throw new ArgumentException("Expected visual parent not found.");
        }
        return aVisualParent;
    }

    public static T FindVisualParentNullable<T>(this DependencyObject aDo) where T : class
    {
        DependencyObject aTmp = aDo;
        do
        {
            aTmp = VisualTreeHelper.GetParent(aTmp);
        }
        while (aTmp as T == null && aTmp != null);
        return aTmp as T;
    }
}